package Test;

import psengine.PSUtil;
import psengine.PSEngine;
import psengine.util.LibraryLoader;
import org.ops.ui.main.swing.PSDesktop;
import bsh.Interpreter;

class Main 
{
    protected static PSEngine psEngine_;
    
    public static void main(String args[]) 
    {
    	try {
    		String debugMode = args[0];
    		PSUtil.loadLibraries(debugMode);	   

    		psEngine_ = PSEngine.makeInstance();
    		psEngine_.start();
    		Runtime.getRuntime().addShutdownHook(new ShutdownHook());
    		loadCustomCode(debugMode);

    		if(args.length > 2 && args[2].equals("nogui"))
    		{
    			Interpreter bshInterpreter_ = new bsh.Interpreter();
    			try {
    				bshInterpreter_.set("psengine", psEngine_);
    				bshInterpreter_.eval("source(\""+args[1]+"\");");
    			}
    			catch (Exception e) {
    				throw new RuntimeException(e);
    			}            		
    		}
    		else
    		{
    			PSDesktop d = PSDesktop.makeInstance(psEngine_,args);
    			d.runUI();
    		}
    	}
    	catch (Exception e) {
    		e.printStackTrace();
    		Runtime.getRuntime().exit(-1);    
    	}
    }

    protected static void loadCustomCode(String debugMode)
    {
    	//Load module with any custom code if it exists:
    	String libName = "Test_" + debugMode;
    	String fullLibName = LibraryLoader.getResolvedName(libName); 
    	if(fullLibName == null) {
    		// Run 'make' to compile the library if you need it:
    		System.out.println("INFO: Custom library " + libName + " wasn't found and won't be loaded.");  
    	}
    	else {
    		System.load(fullLibName);
    		psEngine_.loadModule(fullLibName);
    	}  	
    }
    
    static class ShutdownHook extends Thread 
    {
	    public ShutdownHook()
	    {
	        super("ShutdownHook");
	    }
	    
	    public void run() 
	    {
	        psEngine_.shutdown();
	    }
    }	  
}
